﻿Type=Service
Version=1.16
StartAtBoot=False
@EndOfDesignText@
'Service module
Sub Process_Globals

	Dim Query As String
	Dim Parser As SaxParser
	Dim shouldScheduleNextTask As Boolean
	shouldScheduleNextTask = True 'by default we are scheduling the next update
	
	'private variables
	Dim HC As HttpClient
	Dim URL As String
	URL = "http://search.twitter.com/search.atom?lang=en&q="
	Dim WorkingTwit As Twit
	Dim WorkingTwitsList As List
	Dim su As StringUtils
	Dim Notification1 As Notification
	Dim LastSeenId As String
End Sub
Sub Service_Create
	If Query = "" Then
		'no query means that the process was killed.
		'so we load the query from the state file saved by the activity.
		Dim state As Map
		state = File.ReadMap(File.DirInternal, "state.txt")
		Query = state.Get("EditText1")
		Log("Loading query from file.")
	End If
	Parser.Initialize
	HC.Initialize("HC")
	Notification1.Initialize
	Notification1.Icon = "icon"
	Notification1.Vibrate = False
	Notification1.AutoCancel = True
End Sub

Sub Service_Start
	'schedule the next run in 3 minutes
	If shouldScheduleNextTask Then
		StartServiceAt("", DateTime.Now + 3 * DateTime.TicksPerMinute, False)
	End If
	Dim req As HttpRequest
	req.InitializeGet(URL & su.EncodeUrl(Query, "UTF8"))
	HC.Execute(req, 1)
End Sub

Sub HC_ResponseError (Reason As String, StatusCode As Int, TaskId As Int)
	ToastMessageShow("Error: " & Reason, True)
End Sub

Sub HC_ResponseSuccess (Response As HttpResponse, TaskId As Int)
	Response.GetAsynchronously("Response", File.OpenOutput(File.DirInternalCache, "temp.txt", False), True, TaskId)
End Sub

Sub Response_StreamFinish (Success As Boolean, TaskId As Int)
	If Success Then
		Dim t As Twit
		Dim in As InputStream
		in = File.OpenInput(File.DirInternalCache, "temp.txt")
		LastSeenId = SavedTwits.GetLatestId
		WorkingTwitsList.Initialize
		'parse the new results
		Parser.Parse(in, "Parser")
		in.Close
		If WorkingTwitsList.Size > 0 Then
			t = WorkingTwitsList.Get(0)
			If t.Id = LastSeenId Then
				Log("No new twits found.")
			Else
				SavedTwits.SetTwits(WorkingTwitsList)
				If IsPaused(Main) = False Then
					'update the activity
					CallSub(Main, "UpdateTwits")
				Else
					'show a notification
					Notification1.SetInfo("Twitter demo", t.Title, Main)
					Notification1.Notify(1)
				End If
			End If
		End If
	Else
		ToastMessageShow("Error: " & LastException.Message, True)
	End If
End Sub


Sub Parser_StartElement (Uri As String, Name As String, Attributes As Attributes)
	If name = "entry" Then
		Dim WorkingTwit As Twit
		WorkingTwit.Initialize
	End If
End Sub
Sub Parser_EndElement (Uri As String, Name As String, Text As StringBuilder)
	If parser.Parents.IndexOf("entry") > -1 Then
        If Name = "title" Then
            WorkingTwit.Title = Text.ToString
			Dim m As Matcher
			m = Regex.Matcher("http://[^\s]+", WorkingTwit.Title)
			If m.Find Then
				WorkingTwit.Link = m.Match
			Else
				WorkingTwit.Link = ""
			End If
        Else If Name = "id" Then
			WorkingTwit.Id = Text.ToString
        End If
    End If
    If Name = "entry" Then
		WorkingTwitsList.Add(WorkingTwit)
    End If
End Sub

Sub Service_Destroy

End Sub
