﻿Type=StaticCode
Version=1.16
@EndOfDesignText@
'Code module
'Subs in this code module will be accessible from all modules.
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Type Twit(Link As String, Title As String, Id As String)
	Dim LatestTwits As List
End Sub

Sub GetTwits As List
	If LatestTwits.IsInitialized = False Then LoadTwits
	Return LatestTwits
End Sub

Sub SetTwits(Twits As List)
	LatestTwits = Twits
	If IsPaused(Main) Then
		SaveTwits
	End If
End Sub

Sub SaveTwits
	If LatestTwits.IsInitialized = False Then Return
	Log("Saving twits for later.")
	Dim sb As StringBuilder
	sb.Initialize
	For i = 0 To LatestTwits.Size - 1
		Dim t As Twit
		t = LatestTwits.Get(i)
		sb.Append(t.Link).Append(CRLF).Append(t.Id).Append(CRLF).Append(t.Title.Replace(CRLF, " ")).Append(CRLF)
	Next
	File.WriteString(File.DirInternalCache, "savedTwits.txt", sb.ToString)
End Sub

Sub LoadTwits
	LatestTwits.Initialize
	If File.Exists(File.DirInternalCache, "savedTwits.txt") Then
		Log("reading twits from file.")
		Dim raw As List
		raw = File.ReadList(File.DirInternalCache, "savedTwits.txt")
		For i = 0 To raw.Size - 1 Step 3
			Dim t As Twit
			t.Initialize
			t.Link = raw.Get(i)
			t.Id = raw.Get(i + 1)
			t.Title = raw.Get(i + 2)
			LatestTwits.Add(t)
		Next
	End If
End Sub

Sub GetLatestId As String
	If LatestTwits.IsInitialized = False OR LatestTwits.Size = 0 Then Return ""
	Dim t As Twit
	t = LatestTwits.Get(0)
	Return t.Id
End Sub